Subject: Re: Proposed interface for per-packet mesh-ttl

From: Stephen Hemminger <[email-masked]>
Date: Mon, 30 Jul 2007 21:53:16 +0100

On Mon, 30 Jul 2007 13:37:20 -0700
"Javier Cardona" <[email-masked]> wrote:

> Hi Stephen,
> 
> On 7/27/07, Stephen Hemminger <[email-masked]> wrote:
> > In this case perhaps you can have a table that maps skb->priority to
> > mesh ttl? priorty can already by handled by existing setsockopt calls,
> > and modified by netfilter and QoS managements.
> 
> Thanks for the feedback.  IMHO overloading the [SOL_SOCKET]
> SO_PRIORITY  sockoption for something as different as changing the
> mesh-ttl is quite a stretch.   But I admit that it meets the driver
> requirements of "never add sockopt" and "not [ab]use netfilter hooks".
>  If that's acceptable to all, I'll modify the patch in that direction.
> 
> Cheers,
> 
> Javier

Take it as idea not a proscription.  You can use TC rules to rewrite
the priority.  It is kind of like how priority is being mapped to TOS already
in softmac. Alternatively, the TTL can be set with sockopt, but it is a IP so
it would need an IP ttl to mesh mapping. The fundamental thing is to try
and avoid topology specific options bleeding all the way up the socket layer,
especially since the network layer is involved and may need to multipath.